# Update an identity document

Updates an identity document.

Endpoint: PATCH /v1alpha/documents/{document}
Version: v1alpha
Security: oauth2_client_credentials, oauth2_authorization_code

## Security:

  - `oauth2_client_credentials` (unknown)
    oauth2

  - `oauth2_authorization_code` (unknown)
    oauth2

## Path parameters:

  - `document` (string, required)
    The document id.

## Query parameters:

  - `updateMask` (string)
    Optional. The list of fields to be updated.

 If not provided, the server will update all fields that are populated in
 the `document` message in this request.

 See AIP-134 (Standard Update) and AIP-161 (Field Masks) for more details.

## Request body:

  - `application/json` (unknown)
    Required. The identity document to update.
The document's `name` field is used to identify the document to update.
Format: documents/{document}

## Request fields (application/json):

  - `name` (string)
    (IDENTIFIER) The resource name of the document.
Format: documents/{document}

  - `type` (string)
    Enum: "DOCUMENT_TYPE_UNSPECIFIED", "DRIVERS_LICENCE", "PASSPORT", "AU_MEDICARE_CARD", "VISA", "BIRTH_CERTIFICATE"

  - `entity` (string)
    (OPTIONAL) Optional. The entity this document belongs to.
Format: entities/{entity}

  - `createTime` (string)
    A Timestamp represents a point in time independent of any time zone or local
calendar, encoded as a count of seconds and fractions of seconds at
nanosecond resolution. The count is relative to an epoch at UTC midnight on
January 1, 1970, in the proleptic Gregorian calendar which extends the
Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap
second table is needed for interpretation, using a [24-hour linear
smear](https://developers.google.com/time/smear).
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By
restricting to that range, we ensure that we can convert to and from [RFC
3339](https://www.ietf.org/rfc/rfc3339.txt) date strings.
# Examples
Example 1: Compute Timestamp from POSIX `time()`.
Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX `gettimeofday()`.
struct timeval tv;
gettimeofday(&tv, NULL);
Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`.
FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java `System.currentTimeMillis()`.
long millis = System.currentTimeMillis();
Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java `Instant.now()`.
Instant now = Instant.now();
Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp()
timestamp.GetCurrentTime()
# JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the
[RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the
format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z"
where {year} is always expressed using four digits while {month}, {day},
{hour}, {min}, and {sec} are zero-padded to two digits each. The fractional
seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution),
are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone
is required. A proto3 JSON serializer should always use UTC (as indicated by
"Z") when printing the Timestamp type and a proto3 JSON parser should be
able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past
01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
[toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString)
method. In Python, a standard `datetime.datetime` object can be converted
to this format using
[`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime()) to obtain a formatter capable of generating timestamps in this format.

  - `auMedicareCard` (object, required)

  - `auMedicareCard.cardNumber` (string, required)
    The number shown on the Medicare card.

  - `auMedicareCard.individualReferenceNumber` (integer)
    (OPTIONAL) The individual's reference number on the card (1–4).

  - `auMedicareCard.birthDate` (object)
    Represents a whole or partial calendar date, such as a birthday. The time of
day and time zone are either specified elsewhere or are insignificant. The
date is relative to the Gregorian Calendar. This can represent one of the
following:
* A full date, with non-zero year, month, and day values
* A month and day value, with a zero year, such as an anniversary
* A year on its own, with zero month and day values
* A year and month value, with a zero day, such as a credit card expiration
date

Related types are [google.type.TimeOfDay][google.type.TimeOfDay] and
`google.protobuf.Timestamp`.

  - `auMedicareCard.birthDate.year` (integer)
    Year of the date. Must be from 1 to 9999, or 0 to specify a date without
 a year.

  - `auMedicareCard.birthDate.month` (integer)
    Month of a year. Must be from 1 to 12, or 0 to specify a year without a
 month and day.

  - `auMedicareCard.birthDate.day` (integer)
    Day of a month. Must be from 1 to 31 and valid for the year and month, or 0
 to specify a year by itself or a year and month where the day isn't
 significant.

  - `auMedicareCard.cardType` (string)
    Enum: "CARD_TYPE_UNSPECIFIED", "GREEN", "BLUE", "YELLOW"

  - `auMedicareCard.fullName1` (string)
    (OPTIONAL) Full name of the primary cardholder (line 1).

  - `auMedicareCard.fullName2` (string)
    (OPTIONAL) Optional. Full name of the second cardholder (line 2).

  - `auMedicareCard.fullName3` (string)
    (OPTIONAL) Optional. Full name of the third cardholder (line 3).

  - `auMedicareCard.fullName4` (string)
    (OPTIONAL) Optional. Full name of the fourth cardholder (line 4).

  - `birthCertificate` (object, required)
    birth_certificate.require_au_fields_for_au // AU specific fields must be provided only for AU-issued document

  - `driversLicence` (object, required)
    drivers_licence.require_au_fields_for_au // AU specific fields must be provided only for AU-issued document

  - `passport` (object, required)

  - `passport.passportNumber` (string, required)
    The number shown on the passport.

  - `passport.givenName` (string)
    (OPTIONAL) The individual's given name as it appears on the passport.

  - `passport.middleName` (string)
    (OPTIONAL) Optional. The individual's middle name as it appears on the passport.

  - `passport.familyName` (string)
    (OPTIONAL) The individual's family name as it appears on the passport.

  - `passport.gender` (string)
    (OPTIONAL) The gender of the passport holder, as a single character "M", "F", or "X".

  - `passport.issuingCountry` (string, required)
    ISO 3166-1 alpha-2 country code of the issuing authority.

  - `passport.birthPlace` (string)
    (OPTIONAL) Optional. The place of birth of the passport holder.

  - `passport.nationality` (string)
    (OPTIONAL) Optional. ISO 3166-1 alpha-2 country code of the passport holder's nationality.

  - `visa` (object, required)
    visa.require_au_fields_for_au // AU specific fields must be provided only for AU-issued document

## Response 200:

  - `200` (unknown)
    Success

## Response 200 fields (application/json):

  - `name` (string)
    (IDENTIFIER) The resource name of the document.
Format: documents/{document}

  - `type` (string)
    Enum: "DOCUMENT_TYPE_UNSPECIFIED", "DRIVERS_LICENCE", "PASSPORT", "AU_MEDICARE_CARD", "VISA", "BIRTH_CERTIFICATE"

  - `entity` (string)
    (OPTIONAL) Optional. The entity this document belongs to.
Format: entities/{entity}

  - `createTime` (string)
    A Timestamp represents a point in time independent of any time zone or local
calendar, encoded as a count of seconds and fractions of seconds at
nanosecond resolution. The count is relative to an epoch at UTC midnight on
January 1, 1970, in the proleptic Gregorian calendar which extends the
Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap
second table is needed for interpretation, using a [24-hour linear
smear](https://developers.google.com/time/smear).
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By
restricting to that range, we ensure that we can convert to and from [RFC
3339](https://www.ietf.org/rfc/rfc3339.txt) date strings.
# Examples
Example 1: Compute Timestamp from POSIX `time()`.
Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX `gettimeofday()`.
struct timeval tv;
gettimeofday(&tv, NULL);
Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`.
FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java `System.currentTimeMillis()`.
long millis = System.currentTimeMillis();
Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java `Instant.now()`.
Instant now = Instant.now();
Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp()
timestamp.GetCurrentTime()
# JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the
[RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the
format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z"
where {year} is always expressed using four digits while {month}, {day},
{hour}, {min}, and {sec} are zero-padded to two digits each. The fractional
seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution),
are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone
is required. A proto3 JSON serializer should always use UTC (as indicated by
"Z") when printing the Timestamp type and a proto3 JSON parser should be
able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past
01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
[toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString)
method. In Python, a standard `datetime.datetime` object can be converted
to this format using
[`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime()) to obtain a formatter capable of generating timestamps in this format.

  - `auMedicareCard` (object, required)

  - `auMedicareCard.cardNumber` (string, required)
    The number shown on the Medicare card.

  - `auMedicareCard.individualReferenceNumber` (integer)
    (OPTIONAL) The individual's reference number on the card (1–4).

  - `auMedicareCard.birthDate` (object)
    Represents a whole or partial calendar date, such as a birthday. The time of
day and time zone are either specified elsewhere or are insignificant. The
date is relative to the Gregorian Calendar. This can represent one of the
following:
* A full date, with non-zero year, month, and day values
* A month and day value, with a zero year, such as an anniversary
* A year on its own, with zero month and day values
* A year and month value, with a zero day, such as a credit card expiration
date

Related types are [google.type.TimeOfDay][google.type.TimeOfDay] and
`google.protobuf.Timestamp`.

  - `auMedicareCard.birthDate.year` (integer)
    Year of the date. Must be from 1 to 9999, or 0 to specify a date without
 a year.

  - `auMedicareCard.birthDate.month` (integer)
    Month of a year. Must be from 1 to 12, or 0 to specify a year without a
 month and day.

  - `auMedicareCard.birthDate.day` (integer)
    Day of a month. Must be from 1 to 31 and valid for the year and month, or 0
 to specify a year by itself or a year and month where the day isn't
 significant.

  - `auMedicareCard.cardType` (string)
    Enum: "CARD_TYPE_UNSPECIFIED", "GREEN", "BLUE", "YELLOW"

  - `auMedicareCard.fullName1` (string)
    (OPTIONAL) Full name of the primary cardholder (line 1).

  - `auMedicareCard.fullName2` (string)
    (OPTIONAL) Optional. Full name of the second cardholder (line 2).

  - `auMedicareCard.fullName3` (string)
    (OPTIONAL) Optional. Full name of the third cardholder (line 3).

  - `auMedicareCard.fullName4` (string)
    (OPTIONAL) Optional. Full name of the fourth cardholder (line 4).

  - `birthCertificate` (object, required)
    birth_certificate.require_au_fields_for_au // AU specific fields must be provided only for AU-issued document

  - `driversLicence` (object, required)
    drivers_licence.require_au_fields_for_au // AU specific fields must be provided only for AU-issued document

  - `passport` (object, required)

  - `passport.passportNumber` (string, required)
    The number shown on the passport.

  - `passport.givenName` (string)
    (OPTIONAL) The individual's given name as it appears on the passport.

  - `passport.middleName` (string)
    (OPTIONAL) Optional. The individual's middle name as it appears on the passport.

  - `passport.familyName` (string)
    (OPTIONAL) The individual's family name as it appears on the passport.

  - `passport.gender` (string)
    (OPTIONAL) The gender of the passport holder, as a single character "M", "F", or "X".

  - `passport.issuingCountry` (string, required)
    ISO 3166-1 alpha-2 country code of the issuing authority.

  - `passport.birthPlace` (string)
    (OPTIONAL) Optional. The place of birth of the passport holder.

  - `passport.nationality` (string)
    (OPTIONAL) Optional. ISO 3166-1 alpha-2 country code of the passport holder's nationality.

  - `visa` (object, required)
    visa.require_au_fields_for_au // AU specific fields must be provided only for AU-issued document

